#include "testlib.h"
#include <iostream>
#include <vector>
#include <set>

using namespace std;

//                   0              1   2              3
const int maxn[4] = {1000'000'000,  6,  1000'000'000,  1000'000'000};

const int MAX_BN_GROUP2 = 1000'000'000;

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);
	int group = stoi(validator.group());
	int b = inf.readInt(2, maxn[group], "b");
	inf.readEoln();
	int n = inf.readInt(1, maxn[group], "n");
	inf.readEoln();
	int m = inf.readInt(1, maxn[group], "m");
	inf.readEoln();
	if (group == 2) {
	    long long bb = 1;
	    for (int i = 0; i < n; ++i) {
	        ensuref(bb <= MAX_BN_GROUP2 / b, "b^n > %d", MAX_BN_GROUP2);
	        bb *= b;
	    }
	}
	inf.readEof();
}
