#include "testlib.h"
#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;


int n, k, max_coor;
string type_of_generator;
vector<pair<int, int>> segments;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    type_of_generator = string(argv[1]);
    if (type_of_generator == "k_lines") {
        n = atoi(argv[2]);
        k = atoi(argv[3]);
        max_coor = atoi(argv[4]);
        set<int> coor[k];
        for (int i = 0; i < n; ++i) {
            int id = rnd.next(0, k - 1);
            if (coor[id].size() + 1 > max_coor) {
                --i;
                continue;
            } 
            for (int t = 0; t < 1; ++t) {
                int new_coor = rnd.next(1, max_coor);
                if (coor[id].count(new_coor)) {
                    --t;
                    continue;
                }
                coor[id].insert(new_coor);
            }
        }
        for (int i = 0; i < k; ++i) {
            coor[i].insert(max_coor + 1);
            while (coor[i].size() > 1) {
                int L = *coor[i].begin();
                coor[i].erase(coor[i].begin());
                int R = *coor[i].begin();
                segments.emplace_back(L, rnd.next(L, R - 1));
            }
        }
    } 
    cout << n << ' ' << max_coor << ' ' << k << '\n';
    shuffle(segments.begin(), segments.end());
    for (auto [L, R] : segments) {
        cout << L << ' ' << R << '\n';
    }
}
