import sys

def main():
    input_data = sys.stdin.readlines()
    n, m, k = map(int, input_data[0].split())

    evs = [0 for i in range(2 * n)]
    for i in range(n):
        l, r = map(int, input_data[i + 1].split())
        evs[2 * i] = (l, i + 1)
        evs[2 * i + 1] = (r + 1, -i - 1)
    evs.sort()

    lim = (1 << k)
    dp = [-1 for i in range(lim)]
    dp[0] = 0;
    used = [False for i in range(k)]
    ln = [0 for i in range(n + 1)]
    odd = []
    for i in range(lim):
        if bin(i).count('1') % 2 == 1:
            odd.append(i)

    last = 0
    for x, id in evs:
        for i in odd:
            if dp[i] != -1:
                dp[i] += x - last
        last = x

        if id > 0:
            now = 0
            while used[now]:
                now += 1
            used[now] = True
            ln[id] = now
            for j in range(lim):
                if not ((j >> now) & 1):
                    dp[j ^ (1 << now)] = dp[j]
        else:
            now = ln[-id]
            used[now] = False
            for j in range(lim - 1, -1, -1):
                if ((j >> now) & 1):
                    dp[j ^ (1 << now)] = max(dp[j ^ (1 << now)], dp[j])
                    dp[j] = -1

    sys.stdout.write(str(dp[0]) + "\n")

main()
