#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

string gen_base(int l, int c)
{
    string alf = "";
    for (int i = 0; i < 26; i++)
        alf += (char)(i + 'a');
    shuffle(alf.begin(), alf.end());
    string s = "";
    for (int i = 0; i < l; i++)
        s += alf[rnd.next(c)];
    return s;
}

string gen_fib(string a, string b, int n)
{
    while (b.size() < n)
    {
        string c = a + b;
        a = b;
        b = c;
    }
    return b.substr(0, n);
}

int main(int argc, char** argv)
{
    registerGen(argc, argv, 1);
    int n = opt<int>("n");
    int f = opt<int>("f");
    int c = 26;
    if (__testlib_opts.find("c") != __testlib_opts.end())
        c = opt<int>("c");
    string sa = gen_base(rnd.next(1, f), c);
    string sb = gen_base(rnd.next(1, f), c);
    string a = gen_fib(sa, sb, n);
    string b = gen_fib(sb, sa, n);
    int len = opt<int>("l");
    int l1 = rnd.next((len + 1) / 2, len);
    int l2 = rnd.next((len + 1) / 2, len);
    int p1 = rnd.next(len - l1 + 1);
    int p2 = rnd.next(len - l2 + 1);
    string s = a.substr(p1, l1) + b.substr(p2, l2);
    if (__testlib_opts.find("t") != __testlib_opts.end())
    {
        int t = opt<int>("t");
        for (int it = 0; it < t; it++)
        {
            if (rnd.next(2))
                a[rnd.next(n)] = (char)(rnd.next(26) + 'a');
            else
                b[rnd.next(n)] = (char)(rnd.next(26) + 'a');
        }
    }
    cout << (int)a.size() << " " << (int)s.size() << "\n";
    cout << a << "\n" << b << "\n" << s << "\n";
    return 0;
}
