#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int M = 5e5 + 239;
const int T = 2 * M;
const int N = 3 * M;

int z[N];

void z_func(string t)
{
    for (int i = 0; i < (int)t.size(); i++)
        z[i] = 0;
    int l = 0;
    int r = 0;
    for (int i = 1; i < (int)t.size(); i++)
    {
        z[i] = min(z[i - l], r - i);
        if (z[i] < 0)
            z[i] = 0;
        while (i + z[i] < (int)t.size() && t[z[i]] == t[i + z[i]])
            z[i]++;
        if (i + z[i] > r)
        {
            l = i;
            r = i + z[i];
        }
    }
}

int n, m, fa[M], fb[M];
string a, b, s;

pair<int, ll> tree[T];

void upd(int i, pair<int, ll> x)
{
    for (; i <= m; i |= i + 1)
    {
        tree[i].first += x.first;
        tree[i].second += x.second;
    }
}

pair<int, ll> gett(int i)
{
    pair<int, ll> ans = make_pair(0, 0);
    for (; i >= 0; i = (i & (i + 1)) - 1)
    {
        ans.first += tree[i].first;
        ans.second += tree[i].second;
    }
    return ans;
}

int main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> m >> a >> b >> s;
    z_func(s + "#" + a);
    for (int i = 0; i < n; i++)
        fa[i] = z[i + m + 1];
    reverse(s.begin(), s.end());
    reverse(b.begin(), b.end());
    z_func(s + "#" + b);
    for (int i = 0; i < n; i++)
        fb[n - i - 1] = z[i + m + 1];
    ll ans = 0;
    for (int j = 0; j < n; j++)
    {
        upd(m - fa[j], make_pair(1, m - fa[j]));
        if (j + 1 - m >= 0)
            upd(m - fa[j + 1 - m], make_pair(-1, fa[j + 1 - m] - m));
        pair<int, ll> t = gett(fb[j]);
        ans += (ll)(fb[j] + 1) * (ll)t.first - t.second;
    }
    cout << ans << "\n";
    return 0;
}
