#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2")

#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 1000 * 1000 + 228;

int n, m;
char a[MAX_N];
char b[MAX_N];
char s[MAX_N];
char cp[2 * MAX_N];
int z[2 * MAX_N];

int main() {
#ifdef CH_EGOR
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
#endif

    scanf("%d%d", &n, &m);
    scanf("%s", a);
    scanf("%s", b);
    scanf("%s", s);

    memcpy(cp, s, sizeof(char) * m);
    cp[m] = '$';
    memcpy(cp + m + 1, b, sizeof(char) * n);
    reverse(cp, cp + m);
    reverse(cp + m + 1, cp + m + n + 1);

    int sz = m + n + 1;
    for (int i = 1, l = 0, r = 0; i < sz; ++i) {
        if (i <= r) {
            z[i] = min(r - i + 1, z[i - l]);
        }
        while (i + z[i] < sz && cp[z[i]] == cp[i + z[i]]) {
            ++z[i];
        }
        if (i + z[i] - 1 > r) {
            l = i;
            r = i + z[i] - 1;
        }
    }
    for (int i = m + 1; i < sz; ++i) {
        z[i - m - 1] = z[i];
    }
    reverse(z, z + n);

    ll ans = 0;
    for (int l1 = 0; l1 < n; ++l1) {
        for (int r1 = l1, target = min(n, l1 + m - 1); r1 < target; ++r1) {
            if (s[r1 - l1] != a[r1]) {
                break;
            }
            int sz = m - (r1 - l1 + 1);
            for (int r2 = max(l1, sz - 1), target = min(n, r1 + sz); r2 < target; ++r2) {
                if (z[r2] >= sz) {
                    ++ans;
                }
            }
        }
    }

    printf("%lld\n", ans);

    return 0;
}

