#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>
#include <functional>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 21;

int n, x, y;
int dp[2][1 << MAX_N];

int get_2n_func(int n, int x, int y, int neutral, const function<int(int, int)>& merge) {
    --x; --y;
    for (int i = 0; i < (1 << n); ++i) {
        dp[0][i] = neutral;
    }
    dp[0][0] = 0;
    int cur = 0;
    for (int i = 0; i < n; ++i, cur ^= 1) {
        for (int j = 0; j < (1 << n); ++j) {
            dp[cur ^ 1][j] = neutral;
        }

        if (i == x) {
            for (int j = 0; j < (1 << n); ++j) {
                if (!((j >> y) & 1)) {
                    dp[cur ^ 1][j ^ (1 << y)] = dp[cur][j];
                }
            }
        } else {
            for (int j = 0; j < (1 << n); ++j) {
                for (int k = 0; k < n; ++k) {
                    if (!((j >> k) & 1)) {
                        dp[cur ^ 1][j ^ (1 << k)] = merge(
                            dp[cur ^ 1][j ^ (1 << k)]
                            , dp[cur][j] + (i + k <= x + y)
                        );
                    }
                }
            }
        }
    }

    return dp[cur][(1 << n) - 1] + 1;
}

pair<int, int> get_2n(int n, int x, int y) {
    return {
        get_2n_func(n, x, y, INF, [](int a, int b) {return a < b ? a : b;})
        , get_2n_func(n, x, y, -INF, [](int a, int b) {return a < b ? b : a;})
    };
}

int main() {
#ifdef CH_EGOR
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
#endif

    scanf("%d%d%d", &n, &x, &y);
    
    if (n > MAX_N) {
        // TL, not RE
        while (true);
    }
    
    pair<int, int> ans = get_2n(n, x, y);
    printf("%d %d\n", ans.first, ans.second);

    return 0;
}

