#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 500 * 1000 + 228;
const int BUBEN = 100 * 1000; // this solution so fast !!

int n;
int arr[MAX_N];
pair<int, int> order[MAX_N];
ll lf[MAX_N];
ll rf[MAX_N];
vector<int> st;

void get_arr(ll vals[]) {
    st.clear();
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && arr[st.back()] >= arr[i]) {
            st.pop_back();
        }
        vals[i] = (ll)(st.empty() ? i + 1 : (i - st.back())) * arr[i] + (st.empty() ? 0 : vals[st.back()]);
        st.push_back(i);
    }
}

int main() {
#ifdef CH_EGOR
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
#endif

    scanf("%d", &n);
    for (int i = 0; i < n; ++i) {
        scanf("%d", &arr[i]);
        order[i] = {arr[i], i};
    }

    get_arr(lf);
    reverse(arr, arr + n);
    get_arr(rf);
    reverse(arr, arr + n);
    reverse(rf, rf + n);

    // Check BUBEN maximum elements
    pair<ll, int> mx = {0, 0};
    sort(order, order + n);
    reverse(order, order + n);
    for (int i = 0; i < min(n, BUBEN); ++i) {
        mx = max(mx, {lf[order[i].second] + rf[order[i].second] - arr[order[i].second], order[i].second});
    }
    for (int i = mx.second - 1; i >= 0; --i) {
        arr[i] = min(arr[i], arr[i + 1]);
    }
    for (int i = mx.second + 1; i < n; ++i) {
        arr[i] = min(arr[i], arr[i - 1]);
    }

    for (int i = 0; i < n; ++i) {
        printf("%d%c", arr[i], " \n"[i == n]);
    }

    return 0;
}


