#include "testlib.h"
#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>
using namespace std;

class Test {
public:
    int n, m, k;
    vector<int> L, R;

    void shuffle_test() {
        vector<int> order(n);
        for (int i = 0; i < n; ++i) order[i] = i;
        shuffle(order.begin(), order.end());
        vector<int> nL = L, nR = R;
        for (int i = 0; i < n; ++i) {
            L[order[i]] = nL[i];
            R[order[i]] = nR[i];
        }
    }

    void make_bubble(int r, int maxc) {
        for (int tm = 0; tm < 20; ++tm) {
            vector<int> coor;
            for (int i = 0; i < n; ++i) {
                coor.push_back(L[i]);
                coor.push_back(R[i]);
            }
            sort(coor.begin(), coor.end());
            if (coor.back() + r > maxc) break;
            int M = rnd.next(coor.size());
            for (int t = 0; t < 2; ++t) {
                for (int i = 0; i < n; ++i) {
                    if (L[i] <= coor[M]) {
                        L[i] -= coor[0] - 1;
                    } else {
                        L[i] += r;
                    }
                }
                swap(L, R);
            }
            m = coor.back() + r;
        }
    }

    void read_test() {
        cin >> n >> m >> k;
        L.resize(n), R.resize(n);
        for (int i = 0; i < n; ++i) {
            cin >> L[i] >> R[i];
        }
    }

    void print_test() {
        cout << n << ' ' << m << ' ' << k << '\n';
        L.resize(n), R.resize(n);
        for (int i = 0; i < n; ++i) {
            cout << L[i] << ' ' << R[i] << '\n';
        }
    }
};

