#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

const int INF = 1e9;

const int N = 5001, K = 10;
const int T = (1 << K) + 321;

int n, m, k;
int ans;
vector<pair<int, int>> event; 

int main() {
	ios::sync_with_stdio(false);
	cin >> n >> m >> k;
	for (int i = 1; i <= n; ++i) {
		int L, R;
		cin >> L >> R;
		++R;
		event.emplace_back(L, i);
		event.emplace_back(R, -i);
	}

	sort(event.begin(), event.end());
	
	if (n >= 30) {
	    // TL, not RE/WA
	    while (true);
	}
	
	for (int mask = 0; mask < (1 << n); ++mask) {
		int alive = 0, cur_ans = 0, last_coor = 0;
		for (auto [coor, id] : event) {
			if (alive & 1) {
				cur_ans += coor - last_coor;
			}
			last_coor = coor;
			if (id > 0) {
				id = id - 1;
				if ((mask >> id) & 1) {
					++alive;
				}
			} else {
				id = -id - 1;
				if ((mask >> id) & 1) {
					--alive;
				}
			}
		}
		ans = max(ans, cur_ans);
	}
	cout << ans << '\n';
}
