#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

const int INF = 1e9;

const int N = 5001, K = 10;
const int T = (1 << K) + 321;

int n, m, k;
int dp[T], cnt_bit[T];

int who[K];
vector<pair<int, int>> event;

int main() {
    ios::sync_with_stdio(false);
    for (int i = 1; i < T; ++i) {
        cnt_bit[i] = (i & 1) + cnt_bit[i >> 1];
    }

    cin >> n >> m >> k;
    for (int i = 1; i <= n; ++i) {
        int L, R;
        cin >> L >> R;
        ++R;
        event.emplace_back(L, -i);
        event.emplace_back(R, i);
    }

    sort(event.begin(), event.end());
    fill(dp + 1, dp + T, -INF);
    int alive = 0;
    int lst_coor = 0;
    for (auto [coor, id] : event) {
        for (int i = 0; i < (1 << alive); ++i) {
            if (cnt_bit[i] & 1) {
                dp[i] += coor - lst_coor;
            }
        }
        lst_coor = coor;
        if (id < 0) {
            id = -id;
            int i = 0;
            while (who[i]) ++i;
            alive = max(alive, i + 1);
            who[i] = id;
            for (int mask = 0; mask < (1 << alive); ++mask) {
                if ((mask >> i) & 1) {
                    dp[mask] = dp[mask ^ (1 << i)];
                }
            }
        } else {
            int i = 0;
            while (who[i] != id) ++i;
            who[i] = 0;
            for (int mask = 0; mask < (1 << alive); ++mask) {
                if ((mask >> i) & 1) {
                    dp[mask ^ (1 << i)] = max(dp[mask ^ (1 << i)], dp[mask]);
                    dp[mask] = -INF;
                }
            }
        }
    }
    cout << dp[0] << '\n';
}
