#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

const int MAX_N = 500 * 1000;
const int MAX_M = 1000 * 1000 * 1000;

void validateTest(int maxn, bool is_equal = false, int maxm = MAX_M)
{
    int n = inf.readInt(1, maxn, "n");
    inf.readSpace();
    int m = inf.readInt(2, min(maxm, 2 * n), "m");
    inf.readEoln();
    string a = inf.readToken(format("[a-z]{%d}", n), "a");
    inf.readEoln();
    string b = inf.readToken(format("[a-z]{%d}", n), "b");
    inf.readEoln();
    string s = inf.readToken(format("[a-z]{%d}", m), "s");
    inf.readEoln();
    inf.readEof();
    if (is_equal)
    {
        for (int i = 1; i < m; i++)
            ensuref(s[0] == s[i], "all symbols in the string s should be equal");
    }
}

int main(int argc, char** argv)
{
    registerValidation(argc, argv);

    if (validator.group() == "1")
        validateTest(20);
    else if (validator.group() == "2")
        validateTest(100);
    else if (validator.group() == "3")
        validateTest(500);
    else if (validator.group() == "4")
        validateTest(5000);
    else if (validator.group() == "5")
        validateTest(100 * 1000);
    else if (validator.group() == "6")
        validateTest(MAX_N, false, 100);
    else if (validator.group() == "7")
        validateTest(MAX_N, true);
    else
        validateTest(MAX_N);

    return 0;
}
