#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 1000 * 1000 + 228;

int n, m;
char a[MAX_N];
char b[MAX_N];
char s[MAX_N];
char cp[2 * MAX_N];
int z[2 * MAX_N];
int sums[MAX_N];
bool good_at[MAX_N];

int get_sum(int l, int r) {
    if (l > r) {
        return 0;
    }
    return sums[r] - (l ? sums[l - 1] : 0);
}

int main() {
#ifdef CH_EGOR
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
#endif

    scanf("%d%d", &n, &m);
    scanf("%s", a);
    scanf("%s", b);
    scanf("%s", s);

    memcpy(cp, s, sizeof(char) * m);
    cp[m] = '$';
    memcpy(cp + m + 1, b, sizeof(char) * n);
    reverse(cp, cp + m);
    reverse(cp + m + 1, cp + m + n + 1);

    int sz = m + n + 1;
    for (int i = 1, l = 0, r = 0; i < sz; ++i) {
        if (i <= r) {
            z[i] = min(r - i + 1, z[i - l]);
        }
        while (i + z[i] < sz && cp[z[i]] == cp[i + z[i]]) {
            ++z[i];
        }
        if (i + z[i] - 1 > r) {
            l = i;
            r = i + z[i] - 1;
        }
    }
    for (int i = m + 1; i < sz; ++i) {
        z[i - m - 1] = z[i];
    }
    reverse(z, z + n);

    for (int i = 0; i < n; ++i) {
        good_at[i] = true;
    }

    ll ans = 0;
    for (int sz = m - 1; sz >= 1; --sz) {
        for (int i = 0; i < n; ++i) {
            sums[i] = (z[i] >= sz) + (i ? sums[i - 1] : 0);
        }
        for (int l1 = 0; l1 < n; ++l1) {
            int r1 = m - sz + l1 - 1;
            if (r1 >= n) {
                break;
            }

            if (!good_at[l1] || s[r1 - l1] != a[r1]) {
                good_at[l1] = false;
                continue;
            }
            ans += get_sum(max(l1, sz - 1), min(n - 1, r1 + sz - 1));
        }
    }

    printf("%lld\n", ans);

    return 0;
}

